diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
index 476c3c5b5..22a18b83c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelOverlayLeaves.java
@@ -1,16 +1,15 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLeaves<T> {
     protected final IconCoordinate overlayTexture;
@@ -21,7 +20,7 @@ public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLea
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         super.render(tessellator, worldSource, tilePos);
 
         renderBlocks.overrideBlockTexture = this.overlayTexture;
@@ -32,45 +31,32 @@ public class BlockModelOverlayLeaves<T extends BlockLogic> extends BlockModelLea
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderStandalone(tessellator, metadata, brightness, alpha, lightmapCoordinate);
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
 
         AABBdc bounds = this.block.getBounds();
-
         IconCoordinate overlayCoord = this.overlayTexture;
-        GL11.glColor4f(brightness, brightness, brightness, alpha);
 
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
-        tessellator.draw();
 
-        tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, overlayCoord);
         tessellator.draw();
-
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
index 5b6112f5b..82ce50ce1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.MathHelper;
@@ -26,14 +26,8 @@ public class BlockModelPebbles<T extends BlockLogic> extends BlockModelStandard<
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(LightmapHelper.max(this.block.getLightmapCoord(worldSource, tilePos), this.block.getLightmapCoord(worldSource, tilePos.down(new TilePos()))));
-        } else {
-            brightness = Math.max(renderBlocks.getBlockBrightness(worldSource, tilePos), renderBlocks.getBlockBrightness(worldSource, tilePos.down(new TilePos())));
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        tessellator.setLightmapCoord1i(LightmapHelper.max(this.block.getLightmapCoord(worldSource, tilePos), this.block.getLightmapCoord(worldSource, tilePos.down(new TilePos()))));
         renderBlocks.renderTopFace(tessellator,
             this.block.getBoundsFromState(worldSource, tilePos),
             tilePos,
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
index ad075a78b..0da7f040e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiePumpkin.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicEdible;
 import net.minecraft.core.util.helper.Side;
@@ -24,7 +25,7 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
         withCustomItemBounds(f, 0.0F, f, 1.0F - f, f1, 1.0F - f);
     }
 
-    public void renderSliceSide(final @NotNull Tessellator tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final @NotNull Side side, final boolean overrideTex) {
+    public void renderSliceSide(final @NotNull TessellatorTerrain tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final @NotNull Side side, final boolean overrideTex) {
         if (overrideTex)
             renderBlocks.overrideBlockTexture = this.insideTexture;
         renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, side, 0);
@@ -32,7 +33,7 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
             renderBlocks.overrideBlockTexture = null;
     }
 
-    private void renderSlice(final @NotNull Tessellator tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final int sliceX, final int sliceZ) {
+    private void renderSlice(final @NotNull TessellatorTerrain tessellator, final @NotNull WorldSource worldSource, final @NotNull AABBdc bounds, @NotNull TilePosc tilePos, final int sliceX, final int sliceZ) {
 
         final double onePix = 0.0625;
         final double sliceWidth = onePix * 8;
@@ -64,7 +65,7 @@ public class BlockModelPiePumpkin<T extends BlockLogicEdible> extends BlockModel
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         final AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
 
         final int meta = worldSource.getBlockData(tilePos);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index 58838765d..a1ba8bb45 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -1,8 +1,9 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.piston.BlockLogicPistonBase;
 import net.minecraft.core.util.helper.Direction;
@@ -45,13 +46,13 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         return renderPistonBase(tessellator, worldSource, tilePos, false);
     }
 
     private boolean headless = false;
 
-    public boolean renderHeadless(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePos tilePos) {
+    public boolean renderHeadless(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePos tilePos) {
         renderBlocks.renderAllFaces = true;
         this.headless = true;
         boolean result = renderPistonBase(tessellator, worldSource, tilePos, true);
@@ -60,7 +61,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
         return result;
     }
 
-    protected boolean renderPistonBase(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean noCulling) {
+    protected boolean renderPistonBase(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean noCulling) {
         int meta = worldSource.getBlockData(tilePos);
         boolean extended = noCulling || (meta & 8) != 0;
         Direction direction = BlockLogicPistonBase.getDirection(meta);
@@ -156,8 +157,8 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderStandalone(tessellator, 1, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, 1, lightmapCoord);
     }
 
     public @NotNull IconCoordinate getFaceTexture() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 29fa670d5..be358a7d8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
@@ -41,11 +40,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         return renderPistonHead(tessellator, worldSource, this.block, tilePos, true);
     }
 
-    public void renderPistonHeadNoCulling(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePos tilePos, boolean flag) {
+    public void renderPistonHeadNoCulling(TessellatorTerrain tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePos tilePos, boolean flag) {
         renderBlocks.renderAllFaces = true;
         renderPistonHead(tessellator, worldSource, block, tilePos, flag);
         renderBlocks.renderAllFaces = false;
@@ -55,15 +54,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         this.faceTextureOverride = faceTexture;
     }
 
-    protected boolean renderPistonHead(Tessellator tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePosc tilePos, boolean flag) {
+    protected boolean renderPistonHead(TessellatorTerrain tessellator, WorldSource worldSource, Block<BlockLogicPistonHead> block, @NotNull TilePosc tilePos, boolean flag) {
         int metadata = worldSource.getBlockData(tilePos);
         Direction direction = BlockLogicPistonHead.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
+        tessellator.setLightmapCoord1i(block.getLightmapCoord(worldSource, tilePos));
         final float f1 = flag ? 1.0F : 0.5F;
         final double width = flag ? 1 : 1 / 2d;
 
@@ -142,39 +137,39 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
         return true;
     }
 
-    private void renderHeadTopBottom(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
+    private void renderHeadTopBottom(final TessellatorTerrain tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
         final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
         final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMin, yMax, zMin, uMax, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
         tessellator.addVertexWithUV(xMax, yMin, zMax, uMin, vMin);
         tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadNorthSouth(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
+    private void renderHeadNorthSouth(final TessellatorTerrain tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
         final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
         final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMin, yMin, zMax, uMax, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
         tessellator.addVertexWithUV(xMax, yMax, zMin, uMin, vMin);
         tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMax);
     }
 
-    private void renderHeadEastWest(final Tessellator tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
+    private void renderHeadEastWest(final TessellatorTerrain tessellator, final double xMin, final double xMax, final double yMin, final double yMax, final double zMin, final double zMax, final float brightness, final double width) {
         final IconCoordinate i = renderBlocks.overrideBlockTexture != null ? renderBlocks.overrideBlockTexture : this.pistonShaft;
         final double uMin = i.getSubIconU(0.5 - this.shaftThickness / 2);
         final double vMin = i.getIconVMin();
         final double uMax = i.getSubIconU(0.5 + this.shaftThickness / 2);
         final double vMax = i.getSubIconV(width);
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         tessellator.addVertexWithUV(xMax, yMin, zMin, uMax, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMin);
         tessellator.addVertexWithUV(xMin, yMax, zMax, uMin, vMin);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index 7edf9ef17..02c3dae91 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -1,9 +1,8 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -14,7 +13,6 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
-import org.lwjgl.opengl.GL11;
 
 public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T> {
     private boolean lavaFlag = false;
@@ -24,7 +22,7 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         this.lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
@@ -39,36 +37,23 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float r = (float) (color >> 16 & 0xff) / 255F;
-            float g = (float) (color >> 8 & 0xff) / 255F;
-            float b = (float) (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        } else {
-            GL11.glColor4f(brightness, brightness, brightness, alpha);
-        }
-        float yOffset = 0.5F;
-
-        GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
 
+        int color = getStandaloneTintColor(metadata);
         this.lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
         final double depthFixOffset = 0.001d;
         AABBd bounds = new AABBd(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
-        renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
+        renderBlockWithBounds(tessellator, bounds, metadata, LightmapHelper.getLightmapCoord(15, 15), color);
 
         renderBlocks.overbright = ob;
         this.lavaFlag = false;
-        if (LightmapHelper.isLightmapEnabled()) {
-            lightmapCoordinate = Minecraft.getMinecraft().thePlayer.getLightmap(1f);
-        }
         bounds.setMin(0, 0, 0).setMax(1, 1, 1);
-        renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
+        renderBlockWithBounds(tessellator, bounds, metadata, lightmapCoord, color);
 
-        GL11.glTranslatef(0.5F, yOffset, 0.5F);
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 364a4033e..faf32094f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRail;
 import net.minecraft.core.block.Blocks;
@@ -31,7 +31,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         IconCoordinate icon = getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta);
         if (renderBlocks.overrideBlockTexture != null) {
@@ -39,16 +39,10 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
         }
         RailDirection railDirection = this.block.getLogic().getRailDirection(worldSource, tilePos);
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            if (renderBlocks.overbright) {
-                tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
-            } else {
-                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-            }
+        if (renderBlocks.overbright) {
+            tessellator.setLightmapCoord1i(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
         } else {
-            if (!renderBlocks.overbright) {
-                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            }
+            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
         }
         if (renderBlocks.overbright) {
             icon = getBlockOverbrightTexture(worldSource, tilePos, Side.BOTTOM);
@@ -57,7 +51,7 @@ public class BlockModelRail<T extends BlockLogicRail> extends BlockModelStandard
             return false;
         }
 
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         final double minU = icon.getIconUMin();
         final double maxU = icon.getIconUMax();
         final double minV = icon.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index db6a31ca3..8091cc88b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -1,8 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicRepeater;
 import net.minecraft.core.block.Blocks;
@@ -20,7 +19,7 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
         super(block);
     }
 
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int meta = worldSource.getBlockData(tilePos);
         int direction = meta & BlockLogicRepeater.MASK_DIRECTION;
 
@@ -46,19 +45,12 @@ public class BlockModelRepeater extends BlockModelStandard<BlockLogicRepeater> {
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         renderBlocks.resetRenderBlocks();
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            int lmc = this.block.getLightmapCoord(worldSource, tilePos);
-            if (this.block.emission > 0) {
-                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-            }
-            tessellator.setLightmapCoord(lmc);
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            if (this.block.emission > 0 || Global.accessor.isFullbrightEnabled()) {
-                brightness = 1.0f;
-            }
+        int lmc = this.block.getLightmapCoord(worldSource, tilePos);
+        if (this.block.emission > 0) {
+            lmc = LightmapHelper.setBlocklightValue(lmc, 15);
         }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(lmc);
+        tessellator.setColorOpaque3f(brightness, brightness, brightness);
         double d = -0.1875D;
         double d1 = 0.0D;
         double d2 = 0.0D;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index 4d5fea1bf..b81a888ad 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.block.BlockLogicLanternFirefly;
@@ -20,7 +20,7 @@ public class BlockModelRope<T extends BlockLogicRope>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         Block<?> below = worldSource.getBlock(tilePos.down(new TilePos()));
         boolean hasFloor = below != null && below.canPlaceOnSurface();
         boolean hasBlockNegX = canConnect(worldSource, tilePos, Direction.WEST);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index 7ecdf85a9..2b25f39d9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -15,7 +15,7 @@ public class BlockModelSeat<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBd bounds = new AABBd(this.block.getBoundsFromState(worldSource, tilePos));
 
         renderBlocks.setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
